<?php 
/* ******************************************************************************************* ->

	EFileCloaker v.0.5beta
			
	How to use:
		1.	Download and extract EFileCloaker in your extension directory.
		2.	Modify your configuration file to auto import the extension folder
			example:
					'import'=>array(
						'application.extensions.*',
					),
		
		3.	Call the widget.
			Example:
                     $this->widget('application.extensions.EFileCloaker', array(
                         'OriginalFileName'=>'Demo File',
                         'OriginalUrl'=>'../../file/demofile.pdf',
                     ));
					
		4. 	Create an action to download files
			Example:
					public function actionDownload()
					{
						$uncloak = new EFileCloaker();
						$uncloak->download();
					}
		
		5. Done
		
	Note:
	Sorry guys, it's still a really rough implementation.
	But I hope it will work just fine. It did with mine at least.
	Will update soon.
 * 
 * History:
 * 11/3/2012  - Refactored variables and function name to be more consistent
 *            - Added support for xsendfile when available in apache
 *              Thanks to Pomstiborius (http://www.yiiframework.com/user/4660/) for pointing it out
 * 13/5/2012  - Added rough support for path url type
 * 14/5/2012  - Implement a template method.
 * 26/5/2012  - Faster implementation.
 *			  - Better support for xsendfile.

<- ************************************************************************************************ */

class EFileCloaker extends CWidget {
  
  public $OriginalFileName; // This would store the name to be shown as the file name.
  public $OriginalUrl; // This is the original url to be the source of the download file.
  public $TemplateView = "";
  
  private $_cloakPrefix = "id";
  private $_cloakAction = "download";
  private $_cloakUrl;
  private $_html;
  private $_fileName = null;
  private $_oldUrlFormat;
  private $_oldShowScriptName;
  
  public function setAction($Action)
  {
    if(is_string($Action)) {
      $this->_cloakAction = $Action;
    } else {
      throw new CException("Action must be string");
    }
  }
  
  public function setFileName($FileName)
  {
    if(is_string($FileName)) {
      $this->OriginalFileName = $FileName;
    } else {
      throw new CException("FileName must be string");
    }
  }
  
  public function setOriginalUrl($FileAddress) {
    if(is_string($FileAddress)) {
      $this->OriginalUrl = $FileAddress;
    } else {
      throw new CException("FileAddress must be string");
    }
  }
  
  public function setCloakPrefix($Prefix) {
    if(is_string($Prefix)) {
      $this->_cloakPrefix = $Prefix;
    } else {
      throw new CException("Prefix must be string");
    }
  }

  public function run() {
    if(!isset ($this->OriginalUrl)) {
      throw new CException("Originalurl is not set or it's empty");
    }
	
	$this->_oldUrlFormat = Yii::app()->urlManager->getUrlFormat();
	$this->_oldShowScriptName = Yii::app()->urlManager->showScriptName;
	
    $this->_setOriginalFile();
    $this->_cloakUrl();
    $this->_createMarkUp();
  }
    
  public function download()
  {
  	$key = "";
	
	$cc = new Controller($this->_genRandomNumber());
  	$ses = new CHttpSession();
  	$ses->open();
	
	if(!array_key_exists($this->_cloakPrefix, $_GET))
	{
		$key = array_keys($_GET);
		$key = array_pop($key);
	}
	
	if($key=="")
	{
		throw new CException("Invalid download url.");
	}
  	
  	if($ses->contains($key))
  	{
	  	$this->OriginalUrl = $ses[$key];
	  	$this->_setOriginalFile(); 

	  	if(!file_exists($this->OriginalUrl))
	  	{
	  		throw new CException("File not found.");
	  	}
	  	
		$req = new CHttpRequest();
        if ( function_exists('apache_get_modules') && in_array('mod_xsendfile', apache_get_modules()) ) { 
		  Yii::trace("Using xsendfile to download data.");
		  $req->xSendFile($this->OriginalUrl, array("terminate"=>false, "saveName"=>$this->OriginalFileName));
        } else {
		  Yii::trace("Using normal sendfile to download data.");
          $req->sendFile($this->OriginalFileName, file_get_contents($this->OriginalUrl), null, false);
        }

		$ses->remove($key);
  	} else 
  	{
  		$cc->redirect(array("/site/index"));
  	}
  }
  
  private function _getFileName()
  {
  	$tmp = explode("/",$this->OriginalUrl);
    $tmp = $tmp[count(explode("/", $this->OriginalUrl))-1];
    return $tmp;
  }
  
  private function _getPath()
  {
    $tmp = explode("/", $this->OriginalUrl);
    array_pop($tmp);
    return implode("/",$tmp);
  }
  
  private function _setOriginalFile()
  {
    $this->OriginalFileName = is_null($this->_fileName)?$this->_getFileName():$this->_fileName;
  }
  
  private function _genRandomNumber()
  {
  	return substr(md5(rand(100,999)), 4,8);
  }
  
  private function _cloakUrl()
  {
  	$random = $this->_genRandomNumber(); 
  	
  	$ses = new CHttpSession();
  	$ses->open();
  	$ses[$random] = $this->OriginalUrl;
  	$this->_configureUrl();
  	$this->_cloakUrl = CHtml::normalizeUrl( array("/".Yii::app()->controller->id . "/" . $this->_cloakAction, $this->_cloakPrefix=>$random) ); 
  	$this->_resetUrl();
  	return  $this->_cloakUrl;
  }
  
  private function _configureUrl()
  {
	Yii::app()->urlManager->setUrlFormat("get");
	Yii::app()->urlManager->showScriptName = true;
  }
  
  private function _resetUrl()
  {
	Yii::app()->urlManager->setUrlFormat($this->_oldUrlFormat);
	Yii::app()->urlManager->showScriptName = $this->_oldShowScriptName;
  }

  private function _createMarkUp() {
	  if(strlen($this->TemplateView) > 0)
	{
		if(stripos($this->TemplateView, "{url}") === false)
		{
			throw new CException("{url} must be defined in the template.");
		}
		
		$this->_html = str_replace(array("{filename}", "{url}"), array($this->OriginalFileName, $this->_cloakUrl), $this->TemplateView);
	} else {
		$this->_html = "<div><a href='".$this->_cloakUrl."'>" . $this->OriginalFileName . "</a></div>";
	}
	

    echo $this->_html;
  }
  
  private function _set($param){
    isset($param) ? $param = $param : $param = "";
  }
}
?>
